"use strict";

Object.defineProperty(exports, "__esModule", {
    value: !0
}), exports.SankeySemanticMark = void 0;

const semantic_mark_1 = require("./semantic-mark"), vgrammar_core_1 = require("@visactor/vgrammar-core"), enums_1 = require("./enums"), vgrammar_util_1 = require("@visactor/vgrammar-util");

class SankeySemanticMark extends semantic_mark_1.SemanticMark {
    constructor(id) {
        super(enums_1.PlotMakType.sankey, id), vgrammar_core_1.Factory.getTransform(enums_1.PlotMakType.sankey) || this._logger.error("Please add this line of code: import { registerSankeyTransforms } from '@visactor/vgrammar-sankey'; \n        and run registerSankeyTransforms() before use sankey"), 
        vgrammar_core_1.Factory.getGlyph("linkPath") || this._logger.error("\n      Please add this line of code: import { registerLinkPathGlyph } from '@visactor/vgrammar-core';\n      add run registerLinkPathGlyph() before use sankey\n      ");
    }
    setMarkType() {
        return vgrammar_core_1.GrammarMarkType.rect;
    }
    setDefaultDataTransform() {
        var _a;
        return [ {
            type: "sankey",
            width: {
                signal: "viewWidth"
            },
            height: {
                signal: "viewHeight"
            },
            nodeKey: null === (_a = this.spec.encode) || void 0 === _a ? void 0 : _a.node
        } ];
    }
    getDataIdOfLink() {
        var _a, _b;
        return `${null !== (_b = null === (_a = this.spec.data) || void 0 === _a ? void 0 : _a.id) && void 0 !== _b ? _b : this.spec.id}-data-link`;
    }
    setMultipleData() {
        return [ {
            id: this.getDataIdOfFiltered(),
            transform: [ {
                type: "map",
                all: !0,
                callback: datum => datum[0].nodes
            } ]
        }, {
            source: this.getDataIdOfMain(),
            id: this.getDataIdOfLink(),
            transform: [ {
                type: "map",
                all: !0,
                callback: datum => datum[0].links
            } ]
        } ];
    }
    parseScaleByEncode(channel, option) {
        return "color" === channel ? {
            type: "ordinal",
            id: this.getScaleId("color"),
            domain: {
                data: this.getDataIdOfFiltered(),
                field: option
            },
            range: this.getPalette()
        } : null;
    }
    convertMarkEncode(encode) {
        var _a, _b, _c, _d;
        const markEncoder = this.convertSimpleMarkEncode(encode), res = {
            x: {
                field: "x0"
            },
            x1: {
                field: "x1"
            },
            y: {
                field: "y0"
            },
            y1: {
                field: "y1"
            }
        };
        if (markEncoder.stroke && (res.stroke = markEncoder.stroke), markEncoder.color) {
            const scaleColorId = this.getScaleId("color"), colorAccessor = (0, vgrammar_util_1.field)(markEncoder.color.field);
            res.fill = (datum, el, params) => params[scaleColorId].scale(colorAccessor(null == datum ? void 0 : datum.datum));
        } else res.fill = null !== (_c = null === (_b = null === (_a = this.spec.style) || void 0 === _a ? void 0 : _a.nodeStyle) || void 0 === _b ? void 0 : _b.fill) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0];
        return res;
    }
    setMainMarkSpec() {
        return {
            key: "key"
        };
    }
    setLabelTextGetter(channel, option) {
        const textGetter = (0, vgrammar_util_1.field)(channel);
        return (datum, el, params) => textGetter(datum.datum);
    }
    setMultiMarksSpec() {
        var _a;
        return [ {
            id: `${this.getMarkId()}-link`,
            type: "glyph",
            glyphType: "linkPath",
            from: {
                data: this.getDataIdOfLink()
            },
            layout: {
                position: "content",
                skipBeforeLayouted: !0
            },
            key: "index",
            dependency: this.viewSpec.scales.map((scale => scale.id)).concat(vgrammar_core_1.SIGNAL_VIEW_BOX),
            animation: this.convertMarkAnimation(),
            encode: Object.assign({}, this.spec.state, {
                enter: Object.assign({
                    backgroundStyle: {
                        fillColor: "#ccc",
                        fillOpacity: .2
                    },
                    fillOpacity: .8,
                    round: !0
                }, null === (_a = this.spec.style) || void 0 === _a ? void 0 : _a.linkStyle),
                update: (datum, el, params) => {
                    var _a, _b, _c, _d;
                    return {
                        direction: datum.vertical ? "vertical" : "horizontal",
                        x0: datum.x0,
                        x1: datum.x1,
                        y0: datum.y0,
                        y1: datum.y1,
                        thickness: datum.thickness,
                        fill: null !== (_c = null === (_b = null === (_a = this.spec.style) || void 0 === _a ? void 0 : _a.linkStyle) || void 0 === _b ? void 0 : _b.fill) && void 0 !== _c ? _c : null === (_d = this.getPalette()) || void 0 === _d ? void 0 : _d[0]
                    };
                }
            })
        } ];
    }
}

exports.SankeySemanticMark = SankeySemanticMark, SankeySemanticMark.type = enums_1.PlotMakType.sankey;
//# sourceMappingURL=sankey.js.map