import type { WordcloudEncodeChannels, WithDefaultEncode, PlotWordcloudEncodeSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec, LabelSpec, InteractionSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class WordcloudSemanticMark extends SemanticMark<PlotWordcloudEncodeSpec, WordcloudEncodeChannels> {
    static readonly type = PlotMakType.wordcloud;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultMarkTransform(): TransformSpec[];
    parseScaleByEncode(channel: WordcloudEncodeChannels, option: ValueOf<WithDefaultEncode<PlotWordcloudEncodeSpec, WordcloudEncodeChannels>, WordcloudEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotWordcloudEncodeSpec, WordcloudEncodeChannels>): GenerateBaseEncodeSpec<PlotWordcloudEncodeSpec>;
    protected parseLabelSpec(): {
        marks: LabelSpec[];
        interactions: InteractionSpec[];
    };
}
