import type { RectXEncodeChannels, PlotRectXEncoderSpec, SemanticTooltipOption, WithDefaultEncode, GenerateBaseEncodeSpec, CrosshairSpec, Nil, ScaleSpec, ValueOf } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { PlotMakType } from './enums';
import { GrammarMarkType } from '@visactor/vgrammar-core';
export declare class RectXSemanticMark extends SemanticMark<PlotRectXEncoderSpec, RectXEncodeChannels> {
    static readonly type = PlotMakType.rectX;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    parseScaleByEncode(channel: RectXEncodeChannels, option: ValueOf<WithDefaultEncode<PlotRectXEncoderSpec, RectXEncodeChannels>, RectXEncodeChannels>): ScaleSpec | Nil;
    setDefaultCrosshair(): Record<string, Pick<CrosshairSpec, 'crosshairShape' | 'crosshairType'>>;
    setDefaultTooltip(): SemanticTooltipOption | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotRectXEncoderSpec, RectXEncodeChannels>): GenerateBaseEncodeSpec<PlotRectXEncoderSpec>;
}
