import type { SunburstEncodeChannels, WithDefaultEncode, PlotSunburstEncodeSpec, GenerateBaseEncodeSpec, Nil, ScaleSpec, ValueOf, TransformSpec, IElement, DataSpec, LabelSpec, InteractionSpec } from '@visactor/vgrammar-core';
import { SemanticMark } from './semantic-mark';
import { GrammarMarkType } from '@visactor/vgrammar-core';
import { PlotMakType } from './enums';
export declare class SunburstSemanticMark extends SemanticMark<PlotSunburstEncodeSpec, SunburstEncodeChannels> {
    static readonly type = PlotMakType.sunburst;
    constructor(id?: string | number);
    setMarkType(): GrammarMarkType;
    setDefaultDataTransform(): TransformSpec[];
    getDataIdOfLabel(): string;
    setMultipleData(): DataSpec[];
    parseScaleByEncode(channel: SunburstEncodeChannels, option: ValueOf<WithDefaultEncode<PlotSunburstEncodeSpec, SunburstEncodeChannels>, SunburstEncodeChannels>): ScaleSpec | Nil;
    convertMarkEncode(encode: WithDefaultEncode<PlotSunburstEncodeSpec, SunburstEncodeChannels>): GenerateBaseEncodeSpec<PlotSunburstEncodeSpec>;
    protected setMainMarkEnterEncode(): any;
    setMainMarkSpec(): {
        key: string;
    };
    protected parseLabelSpec(): {
        marks: LabelSpec[];
        interactions: InteractionSpec[];
    };
    setMultiMarksSpec(): {
        id: string;
        type: string;
        from: {
            data: string;
        };
        layout: {
            position: string;
            skipBeforeLayouted: boolean;
        };
        key: string;
        dependency: string[];
        animation: import("@visactor/vgrammar-core").MarkAnimationSpec;
        encode: {
            enter: Partial<import("@visactor/vrender-core").ITextGraphicAttribute>;
            update: (datum: any, el: IElement, params: any) => {
                x: any;
                y: any;
                textAlign: any;
                textBaseline: any;
                text: any;
                angle: any;
                maxLineWidth: any;
            };
        };
    }[];
}
